# Struct hyper::client::conn::Builder [−] [src]

    pub struct Builder { /* fields omitted */ }

A builder to configure an HTTP connection.

After setting options, the builder is used to create a handshake future.

## Implementations

### `impl Builder` [src]

#### `pub fn new() -> Builder` [src]

Creates a new connection builder.

#### `pub fn executor<E>(&mut self, exec: E) -> &mut Builder where
E: Executor<Pin<Box<dyn Future<Output = ()> + Send>>> + Send + Sync + 'static,` [src]

Provide an executor to execute background HTTP2 tasks.

#### `pub fn http2_only(&mut self, enabled: bool) -> &mut Builder` [src]

Sets whether HTTP2 is required.

Default is false.

#### `pub fn http2_initial_stream_window_size(
&mut self,
sz: impl Into<Option<u32>>
) -> &mut Self` [src]

Sets the `SETTINGS_INITIAL_WINDOW_SIZE` option for HTTP2 stream-level flow control.

Passing `None` will do nothing.

If not set, hyper will use a default.

#### `pub fn http2_initial_connection_window_size(
&mut self,
sz: impl Into<Option<u32>>
) -> &mut Self` [src]

Sets the max connection-level flow control for HTTP2

Passing `None` will do nothing.

If not set, hyper will use a default.

#### `pub fn http2_adaptive_window(&mut self, enabled: bool) -> &mut Self` [src]

Sets whether to use an adaptive flow control.

Enabling this will override the limits set in `http2_initial_stream_window_size` and `http2_initial_connection_window_size`.

#### `pub fn http2_max_frame_size(&mut self, sz: impl Into<Option<u32>>) -> &mut Self` [src]

Sets the maximum frame size to use for HTTP2.

Passing `None` will do nothing.

If not set, hyper will use a default.

#### `pub fn http2_keep_alive_interval(
&mut self,
interval: impl Into<Option<Duration>>
) -> &mut Self` [src]

Sets an interval for HTTP2 Ping frames should be sent to keep a connection alive.

Pass `None` to disable HTTP2 keep-alive.

Default is currently disabled.

# Cargo Feature

Requires the `runtime` cargo feature to be enabled.

#### `pub fn http2_keep_alive_timeout(&mut self, timeout: Duration) -> &mut Self` [src]

Sets a timeout for receiving an acknowledgement of the keep-alive ping.

If the ping is not acknowledged within the timeout, the connection will be closed. Does nothing if `http2_keep_alive_interval` is disabled.

Default is 20 seconds.

# Cargo Feature

Requires the `runtime` cargo feature to be enabled.

#### `pub fn http2_keep_alive_while_idle(&mut self, enabled: bool) -> &mut Self` [src]

Sets whether HTTP2 keep-alive should apply while the connection is idle.

If disabled, keep-alive pings are only sent while there are open request/responses streams. If enabled, pings are also sent when no streams are active. Does nothing if `http2_keep_alive_interval` is disabled.

Default is `false`.

# Cargo Feature

Requires the `runtime` cargo feature to be enabled.

#### `pub fn handshake<T, B>(
&self,
io: T
) -> impl Future<Output = Result<(SendRequest<B>, Connection<T, B>)>> where
T: AsyncRead + AsyncWrite + Unpin + Send + 'static,
B: HttpBody + 'static,
B::Data: Send,
B::Error: Into<Box<dyn StdError + Send + Sync>>,` [src]

Constructs a connection with the configured options and IO.

## Trait Implementations

### `impl Clone for Builder` [src]

#### `fn clone(&self) -> Builder` [src]

Returns a copy of the value. Read more

#### `pub fn clone_from(&mut self, source: &Self)`1.0.0 [src]

Performs copy-assignment from `source`. Read more

### `impl Debug for Builder` [src]

#### `fn fmt(&self, f: &mut Formatter<'_>) -> Result` [src]

Formats the value using the given formatter. Read more

## Auto Trait Implementations

### `impl !RefUnwindSafe for Builder`

### `impl Send for Builder`

### `impl Sync for Builder`

### `impl Unpin for Builder`

### `impl !UnwindSafe for Builder`

## Blanket Implementations

### `impl<T> Any for T where
T: 'static + ?Sized,` [src]

#### `pub fn type_id(&self) -> TypeId` [src]

Gets the `TypeId` of `self`. Read more

### `impl<T> Borrow<T> for T where
T: ?Sized,` [src]

#### `pub fn borrow(&self) -> &T` [src]

Immutably borrows from an owned value. Read more

### `impl<T> BorrowMut<T> for T where
T: ?Sized,` [src]

#### `pub fn borrow_mut(&mut self) -> &mut T` [src]

Mutably borrows from an owned value. Read more

### `impl<T> From<T> for T` [src]

#### `pub fn from(t: T) -> T` [src]

Performs the conversion.

### `impl<T> Instrument for T` [src]

#### `pub fn instrument(self, span: Span) -> Instrumented<Self>` [src]

Instruments this type with the provided `Span`, returning an `Instrumented` wrapper. Read more

#### `pub fn in_current_span(self) -> Instrumented<Self>` [src]

Instruments this type with the current `Span`, returning an `Instrumented` wrapper. Read more

### `impl<T, U> Into<U> for T where
U: From<T>,` [src]

#### `pub fn into(self) -> U` [src]

Performs the conversion.

### `impl<T> ToOwned for T where
T: Clone,` [src]

#### `type Owned = T`

The resulting type after obtaining ownership.

#### `pub fn to_owned(&self) -> T` [src]

Creates owned data from borrowed data, usually by cloning. Read more

#### `pub fn clone_into(&self, target: &mut T)` [src]

🔬 This is a nightly-only experimental API. (`toowned_clone_into`)

recently added

Uses borrowed data to replace owned data, usually by cloning. Read more

### `impl<T, U> TryFrom<U> for T where
U: Into<T>,` [src]

#### `type Error = Infallible`

The type returned in the event of a conversion error.

#### `pub fn try_from(value: U) -> Result<T, <T as TryFrom<U>>::Error>` [src]

Performs the conversion.

### `impl<T, U> TryInto<U> for T where
U: TryFrom<T>,` [src]

#### `type Error = <U as TryFrom<T>>::Error`

The type returned in the event of a conversion error.

#### `pub fn try_into(self) -> Result<U, <U as TryFrom<T>>::Error>` [src]

Performs the conversion.